<template>
  <v-container>
    <v-row>
      <v-col cols="9">
        <v-card-actions>
          <v-checkbox
              :disabled="statusProgress"
              v-model="isImport"
              label="IMPORT"
              class="shrink mr-2 mt-0"
              @change="doChangeImport"
          />
          <v-file-input label="Upload File Excel 97-2003" ref="import" :disabled="statusProgress || !isImport" show-size accept=".xls" @change="doUpload" />
          <v-spacer />
          <v-btn @click="doDownload" :disabled="statusProgress || !isImport">Downlod Template</v-btn>
        </v-card-actions>
        <v-card-actions>
          <v-btn @click="doAdd" :disabled="statusProgress || isImport">Add New</v-btn>
          <v-btn @click="doDeleteAll" :disabled="statusProgress || isImport">Delete All</v-btn>
          <v-spacer />
          <v-btn @click="doProccess" :disabled="statusProgress">Proccess</v-btn>
          <v-btn @click="showProgress" v-if="showButtonProgress" :disabled="statusProgress">Check Progress</v-btn>
        </v-card-actions>
      </v-col>
    </v-row>
    <v-row v-for="(config, i) in configs" v-bind:key="i">
      <v-col cols="3">
        <v-text-field v-model="config.ip_gpon" ref="ip_gpon" :disabled="statusProgress" :readonly="isImport" @change="doCheckGpon(i)" label="IP GPON" />
      </v-col>
      <v-col cols="1">
        <v-text-field type="number" v-model="config.slot" :disabled="statusProgress" :readonly="isImport" label="Slot"/>
      </v-col>
      <v-col cols="1">
        <v-text-field type="number" v-model="config.port" :disabled="statusProgress" :readonly="isImport" label="Port"/>
      </v-col>
      <v-col cols="3">
        <v-text-field v-model="config.onu_id" :disabled="statusProgress" :readonly="isImport" label="SN ONT"/>
      </v-col>
      <v-col cols="2">
        <v-btn @click="doDelete(i)">Delete</v-btn>
      </v-col>
    </v-row>
    <v-dialog
        v-model="dlgResult"
        fullscreen
        hide-overlay
        transition="dialog-bottom-transition"
        scrollable
    >
      <v-card tile>
        <v-card-title>
          <v-toolbar
              flat
              dark
              color="primary"
          >
            <v-btn
                icon
                dark
                @click="dlgResult = false"
            >
              <v-icon>mdi-close</v-icon>
            </v-btn>
            <v-toolbar-title>Result</v-toolbar-title>
            <v-spacer></v-spacer>
          </v-toolbar>
        </v-card-title>
        <v-card-text>
          <div v-for="result in results" :key="result.id">
            <div v-html="result.command"></div>
            <div v-html="result.result"></div>
          </div>
        </v-card-text>
      </v-card>
    </v-dialog>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";
import gponService from "../service/GponService";
import configService from "../service/ConfigService";
import {convertExcelTojson} from "../utils/util";
import FileSaver from 'file-saver'

export default {
  name: "BatchDeleteOnt",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      configs: [
        {
          ip_gpon: '',
          slot: '',
          port: '',
          onu_id: '',
        }
      ],
      isImport: false,
      statusProgress: false,
      file: null,
      dlgResult: false,
      results: [],
      showButtonProgress: false,
    }
  },
  methods: {
    async doDownload() {
      this.statusProgress = true
      let filename = 'template_batch_delete_ont.xls'
      await configService.doDownload(filename).then(res => {
        FileSaver.saveAs(res.data, filename)
      }).catch(err => {
        console.log(err)
        console.log(err.response)
        this.$refs.dlgMsg.doOpenMsg(`ERROR EXCEPTION`)
      })
      this.statusProgress = false
    },
    showProgress() {
      this.$router.push(`/progress/batch`)
    },
    doChangeImport() {
      if (this.isImport) {
        this.configs = []
      } else {
        this.$refs.import.value = null
        if (this.configs.length === 0) {
          this.configs.push({
            ip_gpon: null,
            slot: null,
            port: null,
            onu_id: null,
          })
        }
      }
    },
    async doUpload(files) {
      this.statusProgress = true
      if (files) {
        if (files.type !== 'application/vnd.ms-excel') {
          this.$refs.dlgMsg.doOpenMsg('File Harus Excel 97-2003')
          return
        } else if (files.size > 20971520) {
          this.$refs.dlgMsg.doOpenMsg('Ukuran File Tidak Boleh Lebih Dari 20MB')
          return
        }

        await convertExcelTojson(files, 2).then(async res => {
          let configs = res
          this.configs = []
          let i = 0
          for (let config of configs) {
            let isValid = await this.validation(config, i + 1)
            if (!isValid) {
              return
            }
            this.configs.push(config)
            let check = await this.doCheckGpon(i++)
            if (!check) {
              this.doDelete(i - 1)
              this.$refs.import.value = null
              return
            }
          }
          this.$refs.import.value = null
        }).catch(err => {
          console.log(err)
          this.$refs.dlgMsg.doOpenMsg(`ERROR EXCEPTION CONVERT EXCEL TO JSON`)
        })
      }
      this.statusProgress = false
    },
    validation(config, row) {
      let isValid = true
      if (config.ip_gpon == null || config.ip_gpon === '') {
        this.$refs.dlgMsg.doOpenMsg(`IP GPON Tidak Boleh Kosong Pada Baris: ${row}`)
        this.$refs.import.value = null
        isValid = false
      } else if (config.slot == null || config.slot === '') {
        this.$refs.dlgMsg.doOpenMsg(`Slot Tidak Boleh Kosong Pada Baris: ${row}`)
        this.$refs.import.value = null
        isValid = false
      } else if (config.port == null || config.port === '') {
        this.$refs.dlgMsg.doOpenMsg(`Port Tidak Boleh Kosong Pada Baris: ${row}`)
        this.$refs.import.value = null
        isValid = false
      } else if (config.onu_id == null || config.onu_id === '') {
        this.$refs.dlgMsg.doOpenMsg(`SN ONT Tidak Boleh Kosong Pada Baris: ${row}`)
        this.$refs.import.value = null
        isValid = false
      }
      return isValid
    },
    doAdd() {
      this.configs.push({
        ip_gpon: null,
        slot: null,
        port: null,
        onu_id: null,
      })
    },
    doDelete(counter) {
      this.configs.splice(counter, 1)
    },
    doDeleteAll() {
      this.configs = []
    },
    async doProccess() {
      let configs = []
      let i = 1
      if (this.isImport) {
        if (this.configs.length === 0) {
          this.$refs.dlgMsg.doOpenMsg(`File Excel 97-2003 Belum diUpload`)
          return
        }
      }
      for (let data of this.configs) {
        let isValid = await this.validation(data, i++)
        if (!isValid) {
          return
        }
        let config = {
          ip_gpon: data.ip_gpon,
          slot_port: `${data.slot}-${data.port}`,
          onu_id: data.onu_id,
          status: 2,
        }
        configs.push(config)
      }
      console.log(JSON.stringify(configs))

      this.statusProgress = true
      await configService.batch(configs).then(async res => {
        this.results = []
        let {message, data} = res.data
        this.$refs.dlgMsg.doOpenMsg(message, null, data, true)
      }).catch(err => {
        let {message, status} = err.response
        console.log(err)
        console.log(err.response)
        this.$refs.dlgMsg.doOpenMsg(`ERROR EXCEPTION DELETE MASSAL ONT, STATUS: ${status}, MESSAGE: ${message}`)
      })
      this.statusProgress = false
    },
    async doCheckGpon(i) {
      let config = this.configs[i]
      if (config.ip_gpon !== '') {
        let isValid = true
        this.statusProgress = true
        await gponService.getIpAdd(config.ip_gpon).then(async res => {
          isValid = await this.checkResult(i, config, res)
        }).catch(reason => {
          console.log(reason)
          console.log(reason.response)
          this.$refs.dlgMsg.doOpenMsg(`ERROR EXCEPTION`)
        })
        return isValid
      }
    },
    checkResult(i, config, res) {
      let isValid = true
      if (res.data.status === 'FAILED') {
        this.$refs.ip_gpon[i].focus()
        this.$refs.dlgMsg.doOpenMsg(`IP GPON ${config.ip_gpon} Tidak Ditemukan`)
        config.ip_gpon = ''
        isValid = false
      } else {
        let gpon = res.data.data
        if (gpon.nms.protocol === 'SSH2') {
          this.$refs.ip_gpon[i].focus()
          this.$refs.dlgMsg.doOpenMsg(`Protocol NMS Pada IP GPON ${config.ip_gpon} Harus TL1`)
          config.ip_gpon = ''
          isValid = false
        }
      }
      this.statusProgress = this.isImport
      return isValid
    },
  },
}
</script>

<style scoped>

</style>